#include "trithorpe.h"


int expect_error;
int count_error;
int count_expected_error;

void CountBad()
{
	++count_error;
}
void Bad()
{
    if (expect_error) {
	    ++count_expected_error;
    } else {
	CountBad();
#ifdef DEBUG
	// "DEBUG -- STOPPING ON BAD\n";
	// abort();
	Bomb("BAD");
#endif
    }
}				// a place to breakpoint


bool assert_must(bool a, const char *A, int line, const char *file,
		 const char *F)
{
    if (!a) {
	if (expect_error) {
	    ++count_expected_error;
	} else {
	    say << file << "(" << line << ")" << F << ": assertion failed ..... " << A << "\n" ;
	    Bad();
	    return false;
	}
    }
    return true;
}

bool assert_eq(tri a, tri b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    bool z= assert_eq( a.peek(), b.peek(), A, B, line, file, F);
    if (!z) { say << "... " << a << b << '\n' ;}
    return z;
}


bool assert_ne(tri a, tri b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    bool z= assert_ne( a.peek(), b.peek(), A, B, line, file, F);
    if (!z) { say << "... " << a << b << '\n' ;}
    return z;
}


bool assert_eq(word a, word b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    if (a != b) {
	if (expect_error) {
	    ++count_expected_error;
	} else {
	    say << file << "(" << line << ")" << F << ": assertion failed ..... " << A << "\n" ;
	    Bad();
	    return false;
	}
    }
    return true;
}

bool assert_ne(word a, word b, const char *A, const char *B, int line,
	       const char *file, const char *F)
{
    if (a == b) {
	if (expect_error) {
	    ++count_expected_error;
	} else {
	    say << file << "(" << line << ")" << F << ": assertion failed ..... " << A << "\n" ;
	    Bad();
	    return false;
	}
    }
    return true;
}

void Say(const char *s)
{
    say << s << "\n";
}

void memcheck() {
#ifdef REFC
    EQ(tab::countCtors, tab::countDtors);
    EQ(count_new, count_delete);
    EQ(count_new_array, count_delete_array);
#endif
}

bool runUnitTests= false;

int trimain(int argc, const char * argv[]);

int main(int argc, const char * argv[])
{
    extern void RunAllTests(void);

    if (argc>1 && argv[1][0]=='-' && argv[1][1]=='t') {

	argv[1]=argv[0], argc--, argv++;

	runUnitTests= true;
	RunAllTests();
    }

    memcheck();

    if ( count_error > 0 ) {
	say << "Failed tests.\n";
	return 7;
    }

    if (runUnitTests) Say("...MAIN\n");

    memcheck();

    int status= trimain(argc, argv);

    memcheck();

    return status;
}
